Widgeds - Educational Widgets / Learning Interactives
=====================================================

Motivation
----------

**IMPORTANT: This Library is on an EARLY ALPHA state, the API is constantly changing.

Exercises that successfully promote interactivity, learner engagement, and learner control often rely on advanced technology like Java, JavaScript, or Flash that most lecturers do not have the time or the skills to master. What we propose is to identify or develop a limited number of exercise's types that rely on advanced technology but in which the content can be defined through the editing of an independent text file, without any knowledge of the technology behind the exercises (details and examples are provided in the accompanying documents). 

Widgeds?
--------

Widgeds are modules for the [Exercist](https://github.com/widged/exercist/) project.

Widged stands for a widget for education, with a widget defined as "portable chunk of code that can be installed and executed within any separate HTML-based web page by an end user without requiring additional compilation" (Wikipedia).

Most widgeds are written as jQuery plugins. [JQuery](http://jquery.com) is a javascript library known for the huge amount of plugins available for download, which can be used to decrease the development time of a site and avoid having to re-invent the wheel where plugins could be re-used. A modular architecture is adopted whereby components are loosely coupled to one another. A scoreboard component exists as a standalone helper that can be added to any widged on demand.

By default, unless specified otherwise, all content is under a dual MIT license and GPL license. 

Check [widgeds@wikispaces](http://widgeds.wikispaces.com/) for live demos.

How to Change Activity Content
------------------------------

To change the activity content go to the folder `[activity]_assets` and replace any image file with your own. Edit the file `index.html` file in any text editor to modify the textual content of an activity.

Reload the web page in your browser

Note: For the demo to work, the files need to be accessed from a network connection. If you are in offline mode, edit the reference to the jQuery library to point to a local instead of a remote file (`http://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js` should become `libs/jquery.min.js` or something of the like)

Criteria for inclusion of new widgeds
-------------------------------------

* Quality of Content
* Potential Effectiveness as a Teaching Tool
* Ease of Use